/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.util.resource.Labels;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarClaseServicioController")
@Scope("prototype")
public class EditarClaseServicioController extends MyGenericForwardComposer {

    @Autowired
    private ClaseServicioService claseServicioService;
    private ClaseServicio claseServicio;
    private MyListbox claseServicioList;
    private MyTextbox txtNome;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarClaseServicioController.class);

    public ClaseServicio getClaseServicio() {
        return claseServicio;
    }

    public void setClaseServicio(ClaseServicio claseServicio) {
        this.claseServicio = claseServicio;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        claseServicio = (ClaseServicio) Executions.getCurrent().getArg().get("claseServicio");
        claseServicioList = (MyListbox) Executions.getCurrent().getArg().get("claseServicioList");

        if (claseServicio.getClaseservicioId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getText();

        try {
            String nomeClaseServicio = claseServicio.getDescclase();
            List<ClaseServicio> lsClaseServicio = claseServicioService.buscarPorNome(nomeClaseServicio);

            if (lsClaseServicio.isEmpty()) {
                claseServicio.setActivo(Boolean.TRUE);
                claseServicio.setFecmodif(Calendar.getInstance().getTime());
                claseServicio.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

                if (claseServicio.getClaseservicioId() == null) {
                    claseServicioService.suscribir(claseServicio);
                    claseServicioList.addItem(claseServicio);
                } else {
                    claseServicioService.actualizacion(claseServicio);
                    claseServicioList.updateItem(claseServicio);
                }

                Messagebox.show(
                        Labels.getLabel("editarClaseServicioController.MSG.suscribirOK"),
                        Labels.getLabel("editarClaseServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarClaseServicioController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error("editarClaseServicioController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarClaseServicioController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) throws InterruptedException {        
        int resp = Messagebox.show(
                Labels.getLabel("editarClaseServicioController.MSG.borrarPergunta"),
                Labels.getLabel("editarClaseServicioController.window.title"),
                Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

        if (resp == Messagebox.YES) {
            claseServicioService.borrar(claseServicio);

            Messagebox.show(
                    Labels.getLabel("editarClaseServicioController.MSG.borrarOK"),
                    Labels.getLabel("editarClaseServicioController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            claseServicioList.removeItem(claseServicio);

            closeWindow();
        }
    }
}
